﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Maps;

namespace XamOrgChartSearch
{
    public partial class MainPage : UserControl
    {
        ObservableCollection<Department> data;
        public MainPage()
        {
            InitializeComponent();
            data = new DepartmentViewModel().Departments;
            this.DataContext = data;
        }

        private List<OrgChartNode> _searchResults = new List<OrgChartNode>();

        private void textBox1_TextChanged(object sender, TextChangedEventArgs e)
        {
            //if (string.IsNullOrWhiteSpace(TextBoxSearchText.Text))
            //{
            //    _searchResults.Clear();
            //}
            //else
            //{
            //    _searchResults = OrgChart.Search(CompareDescription).ToList();
            //    SetHighlights();
            //}
        }

        private bool CompareDescription(object data)
        {
            string searchText = TextBoxSearchText.Text.ToLower();
            string description;
            if (data is Department)
            {
                description = (data as Department).Name.ToLower();
            }
            else if (data is EmployeePosition)
                 {
                     description = (data as EmployeePosition).JobTitle.ToLower();
                 }
            else
                description = (data as Employee).FirstName.ToLower();

            return description.Contains(searchText);
        }

        private void SetHighlights()
        {
            foreach (var node in _searchResults)
            {
                node.Control.Focus();
            }
        }

        private void TextBoxSearchText_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                if (string.IsNullOrWhiteSpace(TextBoxSearchText.Text))
                {
                    _searchResults.Clear();
                }
                else
                {
                    _searchResults = OrgChart.Search(CompareDescription).ToList();
                    SetHighlights();
                }
            }
        }
    }

    public class Department
    {
        public Department(string name)
        {
            this.Name = name;
            this.EmployeePositions = new ObservableCollection<EmployeePosition>();
        }

        public string Name { get; set; }
        public ObservableCollection<EmployeePosition> EmployeePositions { get; set; }
    }

    public class EmployeePosition
    {
        public EmployeePosition(string jobTitle)
        {
            this.JobTitle = jobTitle;
            this.Employees = new ObservableCollection<Employee>();
        }

        public string JobTitle { get; set; }
        public ObservableCollection<Employee> Employees { get; set; }
    }

    public class Employee
    {
        public Employee(string firstName, string lastName, string jobTitle)
        {
            this.FirstName = firstName;
            this.LastName = lastName;
            this.JobTitle = jobTitle;
        }

        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string JobTitle { get; set; }
    }

    public class DepartmentViewModel
    {
        public ObservableCollection<Department> Departments { get; set; }

        public DepartmentViewModel()
        {
            Employee employee1 = new Employee("Rob", "Walters", "Senior Tool Designer");
            Employee employee2 = new Employee("Ovidiu", "Cracium", "Senior Tool Designer");
            Employee employee3 = new Employee("Thierry", "D'Hers", "Tool Designer");
            Employee employee4 = new Employee("Janice", "Galvin", "Tool Designer");

            EmployeePosition position1 = new EmployeePosition("Senior Tool Designer");
            position1.Employees.Add(employee1);
            position1.Employees.Add(employee2);

            EmployeePosition position2 = new EmployeePosition("Tool Designer");
            position2.Employees.Add(employee3);
            position2.Employees.Add(employee4);

            Department department1 = new Department("Tool Design");
            department1.EmployeePositions.Add(position1);
            department1.EmployeePositions.Add(position2);

            this.Departments = new ObservableCollection<Department>();
            this.Departments.Add(department1);
        }
    }
}
